# LicznikPrzebitych Baloników.py
# Przykładowe rozwiązanie zadania
import pygame
import random

CZARNY = (0,0,0)
BIAŁY = (255,255,255)
pygame.init()
ekran = pygame.display.set_mode([800, 600])
pygame.display.set_caption('Przebij balonik')
mysz_w_dół = False
dalej = True
licznik = pygame.time.Clock()
rys = pygame.image.load("SzalonaBuzka.bmp")
kolor_kluczowy = rys.get_at((0,0))
rys.set_colorkey(kolor_kluczowy)
lista_duszków = pygame.sprite.Group()
pygame.mixer.init() # Dodaj dźwięki
trzask = pygame.mixer.Sound("trzask.wav")
czcionka = pygame.font.SysFont("Arial", 24)
licznik_buziek = 0
licznik_przebitych = 0

class Buźka(pygame.sprite.Sprite):
    pos = (0,0)
    xvel = 1
    yvel = 1
    scale = 100

    def __init__(self, pos, xvel, yvel):
        pygame.sprite.Sprite.__init__(self)
        self.image = rys
        self.scale = random.randrange(10,100)
        self.image = pygame.transform.scale(self.image, (self.scale,self.scale))
        self.rect = self.image.get_rect()
        self.pos = pos
        self.rect.x = pos[0] - self.scale/2
        self.rect.y = pos[1] - self.scale/2
        self.xvel = xvel
        self.yvel = yvel

    def update(self):
        self.rect.x += self.xvel
        self.rect.y += self.yvel
        if self.rect.x <= 0 or self.rect.x > ekran.get_width() - self.scale:
            self.xvel = -self.xvel*0.95
        if self.rect.y <= 0 or self.rect.y > ekran.get_height() - self.scale:
            self.yvel = -self.yvel*0.95

while dalej:
    for event in pygame.event.get(): 
        if event.type == pygame.QUIT: 
            dalej = False
                 
        if event.type == pygame.MOUSEBUTTONDOWN:
            if pygame.mouse.get_pressed()[0]: # Lewy przycisk myszy, rysuj
                mysz_w_dół = True
            elif pygame.mouse.get_pressed()[2]: # Prawy przycisk myszy, rozbijaj
                pos = pygame.mouse.get_pos()
                kliknięte_buźki = [s for s in lista_duszków if s.rect.collidepoint(pos)]
                lista_duszków.remove(kliknięte_buźki)
                if len(kliknięte_buźki) > 0:
                    trzask.play()
                    licznik_przebitych += len(kliknięte_buźki)
                    
        if event.type == pygame.MOUSEBUTTONUP:
            mysz_w_dół = False

    ekran.fill(CZARNY)
    lista_duszków.update()
    lista_duszków.draw(ekran)
    licznik.tick(60)
    rysuj_łańcuch = "Utworzone baloniki: " + str(licznik_buziek)
    rysuj_łańcuch += " - Przebite baloniki: " + str(licznik_przebitych)
    if (licznik_buziek > 0):
        rysuj_łańcuch += " - Procent: "
        rysuj_łańcuch += str( round(licznik_przebitych*100/licznik_buziek, 1)) + "%"

    tekst = czcionka.render(rysuj_łańcuch , True, BIAŁY)
    tekst_prost = tekst.get_rect()
    tekst_prost.centerx = ekran.get_rect().centerx
    tekst_prost.y = 10
    ekran.blit (tekst, tekst_prost)

    pygame.display.update()
    if mysz_w_dół:
        szybkość_x = random.randint(-5, 5)
        szybkość_y = random.randint(-5, 5)
        nowaBuźka = Buźka(pygame.mouse.get_pos(), szybkość_x, szybkość_y)
        lista_duszków.add(nowaBuźka)
        licznik_buziek += 1
        
pygame.quit()
